/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/* defines for gizmos */

#define BUTSTRLEN	200
#define LABELSTRLEN	50

#define FONTWIDTH	9	/* for font 0 */
#define BASELINE	9

/* BUTTON STUFF */
#define PUSHBUTTON	3
#define INDICATOR	9
#define BED		10
#define BUTTON		11

#define BUTHEIGHT	28
#define BUTWIDTH	75

typedef struct {
    long xmin,xmax,ymin,ymax;
    char str[BUTSTRLEN+1];
    long active;
    long enable;
    long locate;
    long select;
    long type;
} Button;


/* TEXT BOX STUFF */
#define TBSTRLEN 	200 
#define TEXTHEIGHT	20
#define TEXTBOXHEIGHT   28

typedef struct {
    long	xmin, xmax, ymin;
    char	str[TBSTRLEN+1];
    char	label[LABELSTRLEN+1];
    long	tp1, tp2;
    long	charWidth;
    long	active;
    long	enable;
    long	type;
} TextBox;

TextBox *newtb();

/* TEXT LIST STUFF */
typedef struct {
    long        xmin, xmax, ymin;
    long        listheight;     /* in lines of text */
    char        **strs;
    long        top;    /* index into strs */
    long        count;  /* total number of strings */
    long        selecteditem;
} TextList;

TextList *newtl();

/* Define for the settbtype() and gettypein() flag */
#define TYPEIN_STRING	0
#define TYPEIN_INT	1
#define TYPEIN_FILE	2
#define TYPEIN_FLOAT	3

/* Color Stuff */

void    Black(), White(), TerraCotta(), DkTerraCotta(),
        VyDkGray(), DkGray(), MmGray(), LtGray(), VyLtGray(),
        LtYellow(), Yellow(), MmYellow(), DkYellow(),
	Red(), Background();

Button *newbed(long, long, long, long);
Button *newbut(long, long, long, long);
void drawbut(Button *);
extern long getcurrentcolor();
void setcurrentcolor(long c);
extern void drawedges(long, long, long, long, void (*)(), void (*)());
extern void loadbut(Button *,  char *);
extern void drawbut(Button *);
extern long pressbut(Button *);
extern TextBox  *newtb(long, long, long);
extern void loadtb(TextBox *, char *);
extern long handletb(TextBox *, long, long);
extern void drawtb(TextBox *);
extern long inbut(Button *, long, long);
extern long intb(TextBox *, long, long);
extern void activatetb(TextBox *);
extern void deactivatetb(TextBox *);
extern void freebut(Button *);
extern void freetb(TextBox *);
extern char *gettbstr(TextBox *);

